<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>TokenProvider.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Test App J Hipster</a> &gt; <a href="index.source.html" class="el_package">com.theo.myjhipster.security.jwt</a> &gt; <span class="el_source">TokenProvider.java</span></div><h1>TokenProvider.java</h1><pre class="source lang-java linenums">package com.theo.myjhipster.security.jwt;

import java.nio.charset.StandardCharsets;
import java.security.Key;
import java.util.*;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import io.github.jhipster.config.JHipsterProperties;
import io.jsonwebtoken.*;
import io.jsonwebtoken.io.Decoders;
import io.jsonwebtoken.security.Keys;

@Component
public class TokenProvider {

<span class="fc" id="L27">    private final Logger log = LoggerFactory.getLogger(TokenProvider.class);</span>

    private static final String AUTHORITIES_KEY = &quot;auth&quot;;

    private Key key;

    private long tokenValidityInMilliseconds;

    private long tokenValidityInMillisecondsForRememberMe;

    private final JHipsterProperties jHipsterProperties;

<span class="fc" id="L39">    public TokenProvider(JHipsterProperties jHipsterProperties) {</span>
<span class="fc" id="L40">        this.jHipsterProperties = jHipsterProperties;</span>
<span class="fc" id="L41">    }</span>

    @PostConstruct
    public void init() {
        byte[] keyBytes;
<span class="fc" id="L46">        String secret = jHipsterProperties.getSecurity().getAuthentication().getJwt().getSecret();</span>
<span class="pc bpc" id="L47" title="1 of 2 branches missed.">        if (!StringUtils.isEmpty(secret)) {</span>
<span class="nc" id="L48">            log.warn(&quot;Warning: the JWT key used is not Base64-encoded. &quot; +</span>
                &quot;We recommend using the `jhipster.security.authentication.jwt.base64-secret` key for optimum security.&quot;);
<span class="nc" id="L50">            keyBytes = secret.getBytes(StandardCharsets.UTF_8);</span>
        } else {
<span class="fc" id="L52">            log.debug(&quot;Using a Base64-encoded JWT secret key&quot;);</span>
<span class="fc" id="L53">            keyBytes = Decoders.BASE64.decode(jHipsterProperties.getSecurity().getAuthentication().getJwt().getBase64Secret());</span>
        }
<span class="fc" id="L55">        this.key = Keys.hmacShaKeyFor(keyBytes);</span>
<span class="fc" id="L56">        this.tokenValidityInMilliseconds =</span>
<span class="fc" id="L57">            1000 * jHipsterProperties.getSecurity().getAuthentication().getJwt().getTokenValidityInSeconds();</span>
<span class="fc" id="L58">        this.tokenValidityInMillisecondsForRememberMe =</span>
<span class="fc" id="L59">            1000 * jHipsterProperties.getSecurity().getAuthentication().getJwt()</span>
<span class="fc" id="L60">                .getTokenValidityInSecondsForRememberMe();</span>
<span class="fc" id="L61">    }</span>

    public String createToken(Authentication authentication, boolean rememberMe) {
<span class="fc" id="L64">        String authorities = authentication.getAuthorities().stream()</span>
<span class="fc" id="L65">            .map(GrantedAuthority::getAuthority)</span>
<span class="fc" id="L66">            .collect(Collectors.joining(&quot;,&quot;));</span>

<span class="fc" id="L68">        long now = (new Date()).getTime();</span>
        Date validity;
<span class="fc bfc" id="L70" title="All 2 branches covered.">        if (rememberMe) {</span>
<span class="fc" id="L71">            validity = new Date(now + this.tokenValidityInMillisecondsForRememberMe);</span>
        } else {
<span class="fc" id="L73">            validity = new Date(now + this.tokenValidityInMilliseconds);</span>
        }

<span class="fc" id="L76">        return Jwts.builder()</span>
<span class="fc" id="L77">            .setSubject(authentication.getName())</span>
<span class="fc" id="L78">            .claim(AUTHORITIES_KEY, authorities)</span>
<span class="fc" id="L79">            .signWith(key, SignatureAlgorithm.HS512)</span>
<span class="fc" id="L80">            .setExpiration(validity)</span>
<span class="fc" id="L81">            .compact();</span>
    }

    public Authentication getAuthentication(String token) {
<span class="fc" id="L85">        Claims claims = Jwts.parser()</span>
<span class="fc" id="L86">            .setSigningKey(key)</span>
<span class="fc" id="L87">            .parseClaimsJws(token)</span>
<span class="fc" id="L88">            .getBody();</span>

<span class="fc" id="L90">        Collection&lt;? extends GrantedAuthority&gt; authorities =</span>
<span class="fc" id="L91">            Arrays.stream(claims.get(AUTHORITIES_KEY).toString().split(&quot;,&quot;))</span>
<span class="fc" id="L92">                .map(SimpleGrantedAuthority::new)</span>
<span class="fc" id="L93">                .collect(Collectors.toList());</span>

<span class="fc" id="L95">        User principal = new User(claims.getSubject(), &quot;&quot;, authorities);</span>

<span class="fc" id="L97">        return new UsernamePasswordAuthenticationToken(principal, token, authorities);</span>
    }

    public boolean validateToken(String authToken) {
        try {
<span class="fc" id="L102">            Jwts.parser().setSigningKey(key).parseClaimsJws(authToken);</span>
<span class="fc" id="L103">            return true;</span>
<span class="fc" id="L104">        } catch (io.jsonwebtoken.security.SecurityException | MalformedJwtException e) {</span>
<span class="fc" id="L105">            log.info(&quot;Invalid JWT signature.&quot;);</span>
<span class="fc" id="L106">            log.trace(&quot;Invalid JWT signature trace: {}&quot;, e);</span>
<span class="fc" id="L107">        } catch (ExpiredJwtException e) {</span>
<span class="fc" id="L108">            log.info(&quot;Expired JWT token.&quot;);</span>
<span class="fc" id="L109">            log.trace(&quot;Expired JWT token trace: {}&quot;, e);</span>
<span class="fc" id="L110">        } catch (UnsupportedJwtException e) {</span>
<span class="fc" id="L111">            log.info(&quot;Unsupported JWT token.&quot;);</span>
<span class="fc" id="L112">            log.trace(&quot;Unsupported JWT token trace: {}&quot;, e);</span>
<span class="fc" id="L113">        } catch (IllegalArgumentException e) {</span>
<span class="fc" id="L114">            log.info(&quot;JWT token compact of handler are invalid.&quot;);</span>
<span class="fc" id="L115">            log.trace(&quot;JWT token compact of handler are invalid trace: {}&quot;, e);</span>
<span class="fc" id="L116">        }</span>
<span class="fc" id="L117">        return false;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>